"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Max = void 0;
const Ordering_1 = require("../util/Ordering");
const Aggregator_1 = require("./Aggregator");
class Max extends Aggregator_1.AggregatorComponent {
    constructor() {
        super(...arguments);
        this.state = undefined;
    }
    put(term) {
        if (term.termType !== 'Literal') {
            throw new Error(`Term with value ${term.value} has type ${term.termType} and is not a literal`);
        }
        if (this.state === undefined) {
            this.state = term;
        }
        else if ((0, Ordering_1.orderTypes)(this.state, term) === -1) {
            this.state = term;
        }
    }
    result() {
        if (this.state === undefined) {
            return Max.emptyValue();
        }
        return this.state;
    }
}
exports.Max = Max;
//# sourceMappingURL=Max.js.map